-- Библиотека утилит для работы с таблицами (массивами)
-------------------------------------------------
-- Клонирование таблцы
local function TableClone(Src, Res)
 local function _find(_t, _a)
  for _i,_ in pairs(_t) do
   if _t[_i][1] == _a then
    return _i
   end
  end
  return nil
 end
 if type(Res) ~= 'table' then
  Res = {}
 else
  -- Очистка
  for i,_ in pairs(Res) do
   Res[i] = nil
  end
 end
 local was={}
 for i,v in pairs(Src) do
  if type(v) == 'table' then
   local j=_find(was, v)
   if j then
    Res[i] = was[j][2]
   else
    local aa=TableClone(v)
    table.insert(was, {v,aa})
    Res[i] = aa
   end
  else
   Res[i] = v
  end
 end
 return Res
end
-------------------------------------------------
local function TableToString(arr, sSep, indent, aWas)
 local function _find(_t, _a)
  for _,v in ipairs(_t) do
   if v == _a then
    return true
   end
  end
  _t[#_t+1] = _a
  return false
 end -- _find
 if aWas == nil then aWas = {} end
 local function _Convert(arg, bPoperty)
  if type(arg) == 'string' then
   return ('%q'):format(arg)
  elseif type(arg) == 'function' then
   return bPoperty and 'property' or 'function(...)'
  elseif type(arg) == 'table' then
   if not _find(aWas, arg) then
    return TableToString(arg, sSep, (indent and indent .. ' '), aWas)
   else
    return '{...}'
   end
  else
   return tostring(arg)
  end
 end
 if type(arr) ~= 'table' then return tostring(arr) end
 local res={}
 for _,v in ipairs(arr) do
  table.insert(res, (indent or '').._Convert(v))
 end
 for i,v in pairs(arr) do
  if type(i) ~= 'number' then
   table.insert(res, (indent or '')..i..'='.._Convert(v))
  end
 end
 if arr.properties then
  for i,v in pairs(arr.properties) do
   if type(i) ~= 'number' then
    table.insert(res, (indent or '')..i..'='.._Convert(v,true))
   end
  end
 end
 return '{'..table.concat(res, sSep) .. (indent or '').. '}'
end
-------------------------------------------------
-- Сравнение таблиц "по значению".
-- сравниваются ординарные значения и таблицы.
-- Проблемы - те же, что и в TabToString
local function TableCompare(arr1, arr2)
 local lRez = #arr1 == #arr2
 if lRez then
  for i,v in ipairs(arr1) do
   if type(arr2[i]) ~= type(v) then return false end
   if mf.index('number string boolean', type(v)) >= 0 then
    if arr2[i] ~= v then return false end
   elseif type(v) == 'table' then
    if not TableCompare(v, arr2[i]) then return false end
   end
  end
 end
end

if not _G.BAX then _G.BAX = {} end
_G.BAX.TabUtils =
 {TableClone=TableClone;
  TableCompare=TableCompare;
  TableToString=TableToString;
 }
return _G.BAX.TabUtils